(********************************************************************
 * COPYRIGHT -- Bernecker + Rainer
 ********************************************************************
 * Library: SIKO_AG24
 * File: SIKO_AG24.fun
 * Author: Christian Hoffmann
 * Created: November 06, 2017
 ********************************************************************
 * Functions and function blocks of library SIKO_AG24
 ********************************************************************)

FUNCTION_BLOCK FB_SikoAg24 (*TODO: Add your comment here*) (*$GROUP=User*)
	VAR_INPUT
		nTargetValue : DINT;
		bc00_Off1 : BOOL;
		bc01_Off2 : BOOL;
		bc02_Off3 : BOOL;
		bc03_IntermediateStop : BOOL;
		bc04_StartTravelJob : BOOL;
		bc05_AckError : BOOL;
		bc06_InchingMode1 : BOOL;
		bc07_Inching2Pos : BOOL;
		bc08_Inching2Neg : BOOL;
		bc09_KeyEnable : BOOL;
		bc10_MoveRelative : BOOL;
		bc11 : BOOL;
		bc12 : BOOL;
		bc13 : BOOL;
		bc14 : BOOL;
		bc15_Cal : BOOL;
		bcDigitalOutput1 : BOOL;
		DC_sModulename : STRING[8];
		DC_sDevicename : STRING[80];
		DC_nNodeId : USINT;
		DC_nStatusWord : UINT;
		DC_nActualValue : DINT;
		DC_nGenMapCh : DINT;
		DC_nDigitalInputsState : UINT;
		DC_pstParameterAg24 : REFERENCE TO ST_ParameterAg24;
		bcStartRead : BOOL;
		bcStartWrite : BOOL;
		bcStartCopy : BOOL;
		bcStartReadDataObj : BOOL;
		bcStartWriteDataObj : BOOL;
	END_VAR
	VAR_OUTPUT
		nActualValue : DINT;
		bs00_Supply : BOOL;
		bs01_ReadinessToTravel : BOOL;
		bs02_UpperLimit : BOOL;
		bs03_LowerLimit : BOOL;
		bs04_ActuatorTravels : BOOL;
		bs05_InPos : BOOL;
		bs06_ActiveTravelJob : BOOL;
		bs07_Error : BOOL;
		bs08_OperationEnabled : BOOL;
		bs09_SwitchLock : BOOL;
		bs10_TravelJobAck : BOOL;
		bs11 : BOOL;
		bs12_CurrentLimiting : BOOL;
		bs13_LimitSwitch1 : BOOL;
		bs14_LimitSwitch2 : BOOL;
		bs15_CalAck : BOOL;
		bsDigitalInput1 : BOOL;
		bsDigitalInput2 : BOOL;
		bsDigitalInput3 : BOOL;
		bsDigitalInput4 : BOOL;
		nGenMapCh : DINT;
		DC_nControlWord : UINT;
		DC_nTargetValue : DINT;
		DC_nDigitalOutputsControl : UINT;
		bsBusy : BOOL;
		bsError : BOOL;
		bsDone : BOOL;
		nStatus : UINT;
		nErrorInfo : UDINT;
		bsParameterValid : BOOL;
		nCounterRead : USINT;
		nCounterWrite : USINT;
		nCounterCopy : USINT;
	END_VAR
	VAR
		nStatusWord : UINT;
		nDigitalInputsStatus : UINT;
		vnCounterRead : USINT;
		vnCounterWrite : USINT;
		vnCounterCopy : USINT;
		vnCounterLoad : USINT;
		fbEplSDORead : EplSDORead;
		fbEplSDOWrite : EplSDOWrite;
		fbR_TRIG1 : R_TRIG;
		fbR_TRIG2 : R_TRIG;
		fbR_TRIG3 : R_TRIG;
		fbR_TRIG4 : R_TRIG;
		fbR_TRIG5 : R_TRIG;
		vbOsrRead : BOOL;
		vbOsrWrite : BOOL;
		vbOsrCopy : BOOL;
		vbOsrReadDataObj : BOOL;
		vbOsrWriteDataObj : BOOL;
		vnWrState : USINT;
		vnRdState : USINT;
		vnCopyState : USINT;
		vnRdDataObjState : USINT;
		vnWrDataObjState : USINT;
		DatObjInfo_0 : DatObjInfo;
		DatObjDelete_0 : DatObjDelete;
		DatObjCreate_0 : DatObjCreate;
		DatObjRead_0 : DatObjRead;
	END_VAR
	VAR CONSTANT
		RD_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		RD_STATE_INIT_EPL_SDO_READ : USINT := 1; (*1*)
		RD_STATE_EXEC_EPL_SDO_READ : USINT := 2; (*2*)
		WR_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		WR_STATE_INIT_EPL_SDO_WRITE : USINT := 1; (*1*)
		WR_STATE_EXEC_EPL_SDO_WRITE : USINT := 2; (*2*)
		DORD_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		DORD_STATE_IDENTIFY_MODULE : USINT := 1; (*1*)
		DORD_STATE_LOAD_DEFAULTS : USINT := 2; (*2*)
		DORD_STATE_CREATE_MODULE : USINT := 3; (*3*)
		DORD_STATE_LOAD_TO_STRUCT : USINT := 4; (*4*)
		DORD_STATE_SET_PARAMETER_VALID : USINT := 5; (*5*)
		DOWR_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		DOWR_STATE_IDENTIFY_MODULE : USINT := 1; (*1*)
		DOWR_STATE_DELETE_MODULE : USINT := 2; (*2*)
		DOWR_STATE_CREATE_MODULE : USINT := 3; (*3*)
		COPY_STATE_WAIT_RTRIG : USINT := 0; (*0*)
		COPY_STATE_COPY_R_TO_W : USINT := 1; (*1*)
	END_VAR
END_FUNCTION_BLOCK
